import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Bee extends Actor
{
    int direction = 10;
    int drop = 40;
    
    public void addedToWorld(World _world) {
        turn(-90);
    }
    
    public void act() 
    {
        move();
        
        if (hasGoneOffRightBorder() || hasGoneOffLeftBorder()) {
            drop();
            reverseDirection();
        }
        
        Actor hitBaby = getOneIntersectingObject(Baby.class);
        if (hitBaby != null) {
            remove(hitBaby);
            getWorld().removeObjects(getWorld().getObjects(Bee.class));
        }
    }
    
    private void move() {
        setLocation(getX()+direction, getY());
    }
    
    private void drop() {
        setLocation(getX(), getY()+drop);
    }
    
    private void reverseDirection() {
        direction = -(direction);
    }

    private boolean hasGoneOffRightBorder() {
        if (direction > 0) {
            if (getX() >= getWorld().getWidth()) {
                return true;
            }            
        }
        return false;
    }
    
    private boolean hasGoneOffLeftBorder() {
        if (direction < 0) {
            if (getX() <= 0) {
                return true;
            }
        }
        return false;
    }
    
    private void remove(Actor _actor) {
        getWorld().removeObject(_actor);
    }
}
