import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class MyWorld extends World
{
    int numberOfBees = 20;

    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1, false); 
        
        drawBackground();
        addBees();
        addBaby();
    }
    
    private void drawBackground() {
        getBackground().setColor(Color.blue);
        getBackground().fillRect(0,0,getWidth(),550);
        getBackground().setColor(Color.green);
        getBackground().fillRect(0,550,getWidth(),getHeight());
    }
    
    private void addBees() {
        for (int i=0; i<numberOfBees; i++) {
            addObject(new Bee(),(numberOfBees*-100)+(i*100),40);
        }        
    }
    
    private void addBaby() {
        addObject(new Baby(),400,550);
    }
    
    public void act() {        
        if (getObjects(Baby.class).size() == 0) {
            displayMessage("Oh Dear, Baby got stung!" );
        } else if (getObjects(Bee.class).size() == 0) {
            displayMessage("Well Done, Bee's cleared!");
        }
    }
    
    private void displayMessage(String _message) {
        int xRandomPos = Greenfoot.getRandomNumber(800);
        int yRandomPos = Greenfoot.getRandomNumber(500);
        setRandomColor();
        getBackground().drawString(_message, xRandomPos, yRandomPos);
    }
    
    private void setRandomColor() {
        int r = Greenfoot.getRandomNumber(255);
        int g = Greenfoot.getRandomNumber(255);
        int b = Greenfoot.getRandomNumber(255);
        getBackground().setColor(new Color(r,g,b));
    }
}
